unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

function CalcPascal(a, b: Integer): Integer;
begin
  a := a + b - $3FFF;
  if a < 0 then
    Exit(0);
  if a > $FFFF then
    Exit($FFFF);
  Result := a;
end;

function CalcAssembler(a, b: Integer): Integer; assembler; register; nostackframe;
{$asmmode intel}
asm
         MOV     EAX, a
         ADD     EAX, b
         SUB     RAX, $3FFF
         CMP     RAX, 0
         JGE     @weiter
         XOR     RAX, RAX
         JMP     @fertig
         @weiter:
         CMP     RAX, $FFFF
         JLE     @fertig
         MOV     RAX, $FFFF
         @fertig:
end;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  a, b, Start, Stopp: Integer;
begin
  Start := GetTickCount64;

  for a := 0 to $FFFF do
    for b := 0 to $FFFF do
      CalcPascal(a, b);

  Stopp := GetTickCount64;
  Label1.Caption := IntToStr(Stopp - Start) + ' milliseconds';
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  a, b, Start, Stopp: Integer;
begin
  Start := GetTickCount64;

  for a := 0 to $FFFF do
    for b := 0 to $FFFF do
      CalcAssembler(a, b);

  Stopp := GetTickCount64;
  Label2.Caption := IntToStr(Stopp - Start) + ' milliseconds';
end;

end.
